#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys
from PyQt4 import QtGui, QtCore
import time

class AppGlobal(object):
	global_dlg=None

app_global=AppGlobal()	

class TestDialog(QtGui.QDialog):
	def __init__(self,parent=None):
		super(TestDialog,self).__init__(parent)
		time.sleep(5)
		self.setWindowTitle('Reference Dialog')
		self.setGeometry(200, 200, 150, 120)
		self.test_button = QtGui.QPushButton('Close dialog', self)
		self.connect(self.test_button, QtCore.SIGNAL('clicked()'),self.accept)
		
	def onClose(self):
		print self.parent()
		if app_global.global_dlg is None:
			print 'keep a dialoog reference in app_global'
			app_global.global_dlg=self
		self.setParent(None)
	
	def accept(self):
		self.onClose()
		QtGui.QDialog.accept(self)
	
	def reject(self):
		self.onClose()
		QtGui.QDialog.reject(self)
	

class TestWidget(QtGui.QWidget):
	def __init__(self, parent=None):
		QtGui.QWidget.__init__(self, parent)
		self.setGeometry(300, 300, 250, 150)
		self.test_button = QtGui.QPushButton('Open dialog', self)
		self.test_button.setGeometry(10, 10, 200, 35)
		self.test_button1 = QtGui.QPushButton('Change widget', self)
		self.test_button1.setGeometry(10, 60, 200, 35)
		self.connect(self.test_button, QtCore.SIGNAL('clicked()'),self.onClick)
		self.connect(self.test_button1, QtCore.SIGNAL('clicked()'),self.onClick1)
    
	def onClick(self):
		if not app_global.global_dlg:
			print 'new dialog created'
			dlg=TestDialog(self)
			dlg.exec_()
		else:
			try:
				print "open saved dialog"
				#app_global.global_dlg.setParent(self)
				app_global.global_dlg.exec_()	
			except Exception,e:
				print e
				app_global.global_dlg=None
				dlg=TestDialog(self)
				dlg.exec_()
      		
	def onClick1(self):
		#print 'change widget from TestWidget'
		self.parent().setCentralWidget(AnotherWidget())

      
class AnotherWidget(QtGui.QWidget):
	def __init__(self, parent=None):
		QtGui.QWidget.__init__(self, parent)
		self.setGeometry(300, 300, 250, 150)
		self.test_button = QtGui.QPushButton('back', self)
		self.test_button.setGeometry(10, 60, 200, 35)
		self.test_button1 = QtGui.QPushButton('Open Dialog', self)
		self.test_button1.setGeometry(10, 10, 200, 35)
		self.connect(self.test_button, QtCore.SIGNAL('clicked()'),self.onClick)
		self.connect(self.test_button1, QtCore.SIGNAL('clicked()'),self.onClick1)
     
	def onClick(self):
		#print 'change widget from AnotherWidget'
		w=TestWidget()
		self.parent().setCentralWidget(w)
	
	def onClick1(self):
		if not app_global.global_dlg:
			print 'new dialog created'
			dlg=TestDialog(self)
			dlg.exec_()
		else:
			try:
				print "open saved dialog"
				#app_global.global_dlg.setParent(self)
				app_global.global_dlg.exec_()	
			except Exception,e:
				print e
				app_global.global_dlg=None
				dlg=TestDialog(self)
				dlg.exec_()
        
  

class MainApp(QtGui.QMainWindow):
	def __init__(self, parent=None):
		QtGui.QMainWindow.__init__(self, parent)
		self.setGeometry(300, 300, 250, 150)
		self.setWindowTitle('Reference Demo')
		t=TestWidget()
		self.setCentralWidget(t)

app = QtGui.QApplication(sys.argv)
m = MainApp()
m.show()
sys.exit(app.exec_())

